/**
 * COCTMT230100UVSubstance.java
 *
 * File generated from the medication::COCTMT230100UVSubstance uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class COCTMT230100UVSubstance.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "COCT_MT230100UV.Substance", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"code",
	"name",
	"desc",
	"lotNumberText",
	"asSubstanceManufacturer",
	"subIngredient",
	"classCode",
	"determinerCode",
	"nullFlavor"
})
@XmlRootElement(name = "COCT_MT230100UV.Substance")
public class COCTMT230100UVSubstance implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.infr.AllInfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId> templateId;
	@XmlElement(name = "code", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.CE code;
	@XmlElement(name = "name", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication.TN> name;
	@XmlElement(name = "desc", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.ED desc;
	@XmlElement(name = "lotNumberText", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.ST1 lotNumberText;
	@XmlElement(name = "asSubstanceManufacturer", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication.COCTMT230100UVSubstanceManufacturer> asSubstanceManufacturer;
	@XmlElement(name = "subIngredient", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication.COCTMT230100UVSubIngredient> subIngredient;
	@XmlAttribute(name = "classCode", required = true)
	public net.ihe.gazelle.medication.EntityClassManufacturedMaterial classCode;
	@XmlAttribute(name = "determinerCode", required = true)
	public net.ihe.gazelle.medication.EntityDeterminer determinerCode;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.medication.NullFlavor nullFlavor;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.realmCode.add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.realmCode.remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public net.ihe.gazelle.infr.AllInfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(net.ihe.gazelle.infr.AllInfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.infr.AllInfrastructureRootTemplateId templateId_elt) {
	    this.templateId.add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.infr.AllInfrastructureRootTemplateId templateId_elt) {
	    this.templateId.remove(templateId_elt);
	}
	
	/**
	 * Return code.
	 * @return code
	 */
	public net.ihe.gazelle.medication.CE getCode() {
	    return code;
	}
	
	/**
	 * Set a value to attribute code.
	 * @param code.
	 */
	public void setCode(net.ihe.gazelle.medication.CE code) {
	    this.code = code;
	}
	
	
	
	
	/**
	 * Return name.
	 * @return name
	 */
	public List<net.ihe.gazelle.medication.TN> getName() {
		if (name == null) {
	        name = new ArrayList<net.ihe.gazelle.medication.TN>();
	    }
	    return name;
	}
	
	/**
	 * Set a value to attribute name.
	 * @param name.
	 */
	public void setName(List<net.ihe.gazelle.medication.TN> name) {
	    this.name = name;
	}
	
	
	
	/**
	 * Add a name to the name collection.
	 * @param name_elt Element to add.
	 */
	public void addName(net.ihe.gazelle.medication.TN name_elt) {
	    this.name.add(name_elt);
	}
	
	/**
	 * Remove a name to the name collection.
	 * @param name_elt Element to remove
	 */
	public void removeName(net.ihe.gazelle.medication.TN name_elt) {
	    this.name.remove(name_elt);
	}
	
	/**
	 * Return desc.
	 * @return desc
	 */
	public net.ihe.gazelle.medication.ED getDesc() {
	    return desc;
	}
	
	/**
	 * Set a value to attribute desc.
	 * @param desc.
	 */
	public void setDesc(net.ihe.gazelle.medication.ED desc) {
	    this.desc = desc;
	}
	
	
	
	
	/**
	 * Return lotNumberText.
	 * @return lotNumberText
	 */
	public net.ihe.gazelle.medication.ST1 getLotNumberText() {
	    return lotNumberText;
	}
	
	/**
	 * Set a value to attribute lotNumberText.
	 * @param lotNumberText.
	 */
	public void setLotNumberText(net.ihe.gazelle.medication.ST1 lotNumberText) {
	    this.lotNumberText = lotNumberText;
	}
	
	
	
	
	/**
	 * Return asSubstanceManufacturer.
	 * @return asSubstanceManufacturer
	 */
	public List<net.ihe.gazelle.medication.COCTMT230100UVSubstanceManufacturer> getAsSubstanceManufacturer() {
		if (asSubstanceManufacturer == null) {
	        asSubstanceManufacturer = new ArrayList<net.ihe.gazelle.medication.COCTMT230100UVSubstanceManufacturer>();
	    }
	    return asSubstanceManufacturer;
	}
	
	/**
	 * Set a value to attribute asSubstanceManufacturer.
	 * @param asSubstanceManufacturer.
	 */
	public void setAsSubstanceManufacturer(List<net.ihe.gazelle.medication.COCTMT230100UVSubstanceManufacturer> asSubstanceManufacturer) {
	    this.asSubstanceManufacturer = asSubstanceManufacturer;
	}
	
	
	
	/**
	 * Add a asSubstanceManufacturer to the asSubstanceManufacturer collection.
	 * @param asSubstanceManufacturer_elt Element to add.
	 */
	public void addAsSubstanceManufacturer(net.ihe.gazelle.medication.COCTMT230100UVSubstanceManufacturer asSubstanceManufacturer_elt) {
	    this.asSubstanceManufacturer.add(asSubstanceManufacturer_elt);
	}
	
	/**
	 * Remove a asSubstanceManufacturer to the asSubstanceManufacturer collection.
	 * @param asSubstanceManufacturer_elt Element to remove
	 */
	public void removeAsSubstanceManufacturer(net.ihe.gazelle.medication.COCTMT230100UVSubstanceManufacturer asSubstanceManufacturer_elt) {
	    this.asSubstanceManufacturer.remove(asSubstanceManufacturer_elt);
	}
	
	/**
	 * Return subIngredient.
	 * @return subIngredient
	 */
	public List<net.ihe.gazelle.medication.COCTMT230100UVSubIngredient> getSubIngredient() {
		if (subIngredient == null) {
	        subIngredient = new ArrayList<net.ihe.gazelle.medication.COCTMT230100UVSubIngredient>();
	    }
	    return subIngredient;
	}
	
	/**
	 * Set a value to attribute subIngredient.
	 * @param subIngredient.
	 */
	public void setSubIngredient(List<net.ihe.gazelle.medication.COCTMT230100UVSubIngredient> subIngredient) {
	    this.subIngredient = subIngredient;
	}
	
	
	
	/**
	 * Add a subIngredient to the subIngredient collection.
	 * @param subIngredient_elt Element to add.
	 */
	public void addSubIngredient(net.ihe.gazelle.medication.COCTMT230100UVSubIngredient subIngredient_elt) {
	    this.subIngredient.add(subIngredient_elt);
	}
	
	/**
	 * Remove a subIngredient to the subIngredient collection.
	 * @param subIngredient_elt Element to remove
	 */
	public void removeSubIngredient(net.ihe.gazelle.medication.COCTMT230100UVSubIngredient subIngredient_elt) {
	    this.subIngredient.remove(subIngredient_elt);
	}
	
	/**
	 * Return classCode.
	 * @return classCode
	 */
	public net.ihe.gazelle.medication.EntityClassManufacturedMaterial getClassCode() {
	    return classCode;
	}
	
	/**
	 * Set a value to attribute classCode.
	 * @param classCode.
	 */
	public void setClassCode(net.ihe.gazelle.medication.EntityClassManufacturedMaterial classCode) {
	    this.classCode = classCode;
	}
	
	
	
	
	/**
	 * Return determinerCode.
	 * @return determinerCode
	 */
	public net.ihe.gazelle.medication.EntityDeterminer getDeterminerCode() {
	    return determinerCode;
	}
	
	/**
	 * Set a value to attribute determinerCode.
	 * @param determinerCode.
	 */
	public void setDeterminerCode(net.ihe.gazelle.medication.EntityDeterminer determinerCode) {
	    this.determinerCode = determinerCode;
	}
	
	
	
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.medication.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.medication.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "COCT_MT230100UV.Substance").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(COCTMT230100UVSubstance cOCTMT230100UVSubstance, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (cOCTMT230100UVSubstance != null){
   			cvm.validate(cOCTMT230100UVSubstance, location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: cOCTMT230100UVSubstance.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.infr.AllInfrastructureRootTypeId.validateByModule(cOCTMT230100UVSubstance.getTypeId(), location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.infr.AllInfrastructureRootTemplateId templateId: cOCTMT230100UVSubstance.getTemplateId()){
					net.ihe.gazelle.infr.AllInfrastructureRootTemplateId.validateByModule(templateId, location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.medication.CE.validateByModule(cOCTMT230100UVSubstance.getCode(), location + "/code", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.medication.TN name: cOCTMT230100UVSubstance.getName()){
					net.ihe.gazelle.medication.TN.validateByModule(name, location + "/name[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.medication.ED.validateByModule(cOCTMT230100UVSubstance.getDesc(), location + "/desc", cvm, diagnostic);
			net.ihe.gazelle.medication.ST1.validateByModule(cOCTMT230100UVSubstance.getLotNumberText(), location + "/lotNumberText", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.medication.COCTMT230100UVSubstanceManufacturer asSubstanceManufacturer: cOCTMT230100UVSubstance.getAsSubstanceManufacturer()){
					net.ihe.gazelle.medication.COCTMT230100UVSubstanceManufacturer.validateByModule(asSubstanceManufacturer, location + "/asSubstanceManufacturer[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication.COCTMT230100UVSubIngredient subIngredient: cOCTMT230100UVSubstance.getSubIngredient()){
					net.ihe.gazelle.medication.COCTMT230100UVSubIngredient.validateByModule(subIngredient, location + "/subIngredient[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
    	}
    }

}